#################################s#o#q######################################
## by Arthur Chan @ soqhome.com
#############################################################################

from AccessControl import ClassSecurityInfo
from Globals import InitializeClass, package_home
from OFS.SimpleItem import SimpleItem
from Products.CMFCore.CMFCorePermissions  import ModifyPortalContent, ManagePortal
from Products.CMFCore.utils import UniqueObject, getToolByName
from Products.PageTemplates.PageTemplateFile import PageTemplateFile

from Products.QuotaAW.config import *

from Acquisition import aq_parent, aq_base, aq_chain

#from zLOG import LOG, WARNING, BLATHER, INFO
#LOG('Quota', INFO, 'start')

class QuotaTool(UniqueObject, SimpleItem):
    """ Quota Tool  """ 

    id        = 'quota_tool'
    meta_type = 'Quota Tool'
    security = ClassSecurityInfo()
    plone_tool = 1


    # properties
    MAX_QUOTA_BYTES	= 0
    MAX_QUOTA_OBJECTS	= 0
    
    MAX_QUOTA_BYTES	= 0
    MAX_QUOTA_OBJECTS	= 0
    MAX_OBJECT_SIZE	= 0
    IS_ALLOW_NESTED	= 1
    
        
    
    APPLY_SUB_FOLDERISH	= 0
    DISABLE_FOLDERISH_SETTING	= 0
    

    manage_options=(
        ({ 'label'   : 'Config',
           'action'  : 'manage_configForm',
           },
         ) + SimpleItem.manage_options
        )

    security.declareProtected( ManagePortal
                             , 'manage_configForm' )    
    
    manage_configForm = PageTemplateFile('www/config', globals(), __name__='manage_configForm')

    def __init__(self):
        
        self._reset()
        

        #return 0
        
        
    def _reset(self):
        
        self.MAX_QUOTA_BYTES	= 0
        self.MAX_QUOTA_OBJECTS	= 0
        self.MAX_OBJECT_SIZE	= 0
        self.IS_ALLOW_NESTED	= 1
        self.APPLY_SUB_FOLDERISH	= 0
        
        self.DISABLE_FOLDERISH_SETTING	= 0
        return

    
    def _set(self, REQUEST=None, **kwargs):
        if REQUEST==None:
            arglist= kwargs
        else:
            arglist = REQUEST
        
        self.MAX_QUOTA_BYTES	= arglist['MAX_QUOTA_BYTES']
        self.MAX_QUOTA_OBJECTS	= arglist['MAX_QUOTA_OBJECTS']
        self.MAX_OBJECT_SIZE	= arglist['MAX_OBJECT_SIZE']
        self.IS_ALLOW_NESTED	= arglist['IS_ALLOW_NESTED']
        
        
        
        self.APPLY_SUB_FOLDERISH	= arglist['APPLY_SUB_FOLDERISH']
        self.DISABLE_FOLDERISH_SETTING	= arglist['DISABLE_FOLDERISH_SETTING']
        
    
    
    def _updateAllFolders(self):
        # QuotaAW        
        items= self.portal_catalog(meta_type='QuotaAW')
        for i in items:
            obj = i.getObject()
            obj.setMax_quota_bytes(self.MAX_QUOTA_BYTES, force=1)
            obj.setMax_quota_objects(self.MAX_QUOTA_OBJECTS, force=1)
            obj.setMax_object_size(self.MAX_OBJECT_SIZE, force=1)
            
            obj.setApply_sub_folderish(self.APPLY_SUB_FOLDERISH)
            
    
    def manage_configfolder(self, submit, \
                         REQUEST=None, **kwargs):
    
        """config this puppy"""
        if submit == "Update All":
            self._set(REQUEST=REQUEST, **kwargs)
            self._updateAllFolders()
        elif submit == "Save Config":
            self._set(REQUEST=REQUEST, **kwargs)
        
        if self.DISABLE_FOLDERISH_SETTING:
            self._updateAllFolders()

        if REQUEST:
            return REQUEST.RESPONSE.redirect('/'.join(folder.getPhysicalPath()) + \
                                             "/manage_configForm?portal_status_message=Config+Updated")
    
    ##### Utils #####
    
    
    security.declarePublic('getMax_quota_bytes' )
    def getMax_quota_bytes(self, folder):
        quota = self.getQuotaAW(folder)
        return quota.getMax_quota_bytes()
        
        
    security.declarePublic('getMax_quota_objects' )
    def getMax_quota_objects(self, folder):
        quota = self.getQuotaAW(folder)
        return quota.getMax_quota_objects()
        
    security.declarePublic('getMax_object_size' )
    def getMax_object_size(self, folder):
        quota = self.getQuotaAW(folder)
        return quota.getMax_object_size()
        

    
    ##### Accessor #####
    security.declarePublic('getCurrentCount' )
    def getCurrentCount(self, folder):
        #path=folder.absolute_url('relative')
        path = '/'.join(folder.getPhysicalPath())
        #path=path.replace('%20', ' ')
        items= self.portal_catalog(path=path)
        #items= self.filterCategory(folder, items)
        ret = 0
        for i in items:
        #    o = i.getObject()
        #    if o <> aq_base(folder) and o.meta_type != 'QuotaAW':
            if i.meta_type <> 'QuotaAW':
                ret = ret +1
        
        return ret  -1 #(minus parent folder) 
        
        
        #return len(items)


    security.declarePublic('getCurrentMaxObjectPath')
    def getCurrentMaxObjectPath(self, folder):
        #path=folder.absolute_url('relative')
        path = '/'.join(folder.getPhysicalPath())
        #path=path.replace('%20', ' ')
        items= self.portal_catalog(path=path )
        maxsize=0
        maxobjpath =''
        for i in items:
            if i.meta_type <> 'QuotaAW':
                o = i.getObject()
                if o !=  aq_base(folder):
                    if hasattr(o, 'get_size'):
                        try:
                            size =o.get_size()
                        
                            if size > maxsize:
                                maxsize=size
                                #maxobjpath = o.absolute_url('relative')
                                maxobjpath = '/'.join(o.getPhysicalPath())
                        except:
                            continue    
        return maxobjpath.replace('%20', ' ')
    
    security.declarePublic('getCurrentSize' )
    def getCurrentSize(self, folder):
        path = '/'.join(folder.getPhysicalPath()) # folder.absolute_url('relative')
        #path=path.replace('%20', ' ' )
        items= self.portal_catalog(path= path)
        #items= self.filterCategory(folder, items, category, lists)
        sum = 0
        for i in items:
            if i.meta_type <> 'QuotaAW':
                o = i.getObject()
                if o !=  aq_base(folder):
                    if hasattr(o, 'get_size'):
                        try:
                            sum = sum +  o.get_size()
                        except:
                            continue                
        return sum
        
    ### Checking functions ####
    security.declarePublic('check_over_count' )
    def check_over_count(self, quotaaw):
        quota = quotaaw.getMax_quota_objects()
        if not quota:
            return 0
        quota = int(quota)
        
        return self.getCurrentCount( aq_parent(quotaaw)) > quota

    security.declarePublic('check_over_size' )
    def check_over_size(self, quotaaw):
        
        quota = quotaaw.getMax_quota_bytes()
        if not quota:
            return 0
        quota = int(quota)
        return self.getCurrentSize( aq_parent(quotaaw)) > quota

    security.declarePublic('check_object_over_size' )
    def check_object_over_size(self, quotaaw):
        quota = quotaaw.getMax_object_size()
        if not quota:
            return 0
        quota = int(quota)
        path = self.getCurrentMaxObjectPath(aq_parent(quotaaw))
        if not path:
            return 0
        obj = self.restrictedTraverse(path)
        try:
            return obj.get_size() > quota
        except:
            return 0

    security.declarePublic( 'getFileSizeStr' )
    def getFileSizeStr(self, bytes):
    
        try:
            
            """
            Format a number of bytes as bytes, K, or MB.
            """
            megs=bytes / 1048576.0
            if megs > 1:
                return "%.2f MB" % megs
            k=bytes / 1024.0
            if k > 1:
                return "%d K" % k
            return "%d bytes" % bytes
        except:
            return None

    security.declarePublic('getCheckFolder')
    def getCheckFolder(self, item=None):
        tool = self.quota_tool
        url = self.portal_url
        #shadowparent = None
        if not item:
            return None
        for parent in item.aq_chain:
                
            if not parent:
                return None
            if not hasattr(parent, 'meta_type'):
                
                return None
            if parent.meta_type =='QuotaAW' or not parent.isPrincipiaFolderish:
                continue
                
            #if not shadowparent and parent.isPrincipiaFolderish:
            #    shadowparent = parent
            
            if not hasattr(parent, 'contentValues'):
                return None
            
            
            quotas = parent.contentValues(filter={'portal_type':'QuotaAW',})
            
            parentphy = parent.getPhysicalPath()
            if len(quotas)>0:
                if not hasattr(quotas[0], 'getRestart_level'):
                    
                    return None
                restartlvls = quotas[0].getRestart_level()
                myphy = item.getPhysicalPath()
                rlist = []
                for l in restartlvls:
                    rlist.append(l)
                rlist.sort()
                rlist.reverse()
                for lvl in rlist:
                    
                    try:
                        lvl = int(lvl)
                        if len(myphy) >= len(parentphy) + lvl:
                            len(parentphy) + lvl
                            shadowphy = myphy[:len(parentphy) + lvl]
                            
                            shadowparent= self.restrictedTraverse('/'.join(shadowphy))
                            
                            if shadowparent.isPrincipiaFolderish:
                                return shadowparent
                        else:
                            continue
                    except:
                        continue
            #if hasattr(parent, 'getPhysicalPath') and '/'.join(parent.getPhysicalPath()) in checkpaths:
            #    if tool.APPLY_SUB_FOLDERISH:    # grab from tool return first parent if apply sub folderish
            #        return shadowparent
            #    else: 
            #        return parent
            #if hasattr(parent, 'getPhysicalPath') and '/'.join(parent.getPhysicalPath())==portalpath:
            #    return None
            
        return None


    security.declarePublic('getQuotaAW')
    def getQuotaAW(self, item):
        parent = item
        for parent in item.aq_chain:
            
            quotas = parent.contentValues(filter={'portal_type':'QuotaAW',})
            if len(quotas)>0:
                return quotas[0]
        return None

    

InitializeClass(QuotaTool)
